package xdoclet.modules.ojb.model;

/* Copyright 2004-2005 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Represents a nested object.
 *
 * @author <a href="mailto:tomdz@users.sourceforge.net">Thomas Dudziak (tomdz@users.sourceforge.net)</a>
 */
public class NestedDef extends DefBase
{
    /** The type of the nested object */
    private ClassDescriptorDef _nestedClassDef;

    /**
     * Creates a new nested wrapper object.
     *
     * @param name The name of the java attribute
     */
    public NestedDef(String name, ClassDescriptorDef classDef)
    {
        super(name);
        _nestedClassDef = classDef;
    }

    /**
     * Returns the type of the nested object.
     * 
     * @return The class descriptor for the nested object type
     */
    public ClassDescriptorDef getNestedType()
    {
        return _nestedClassDef;
    }
}
